/*
 * File: CaesarCipher.java
 * -----------------------
 * This program translates a line of text into its Caesar cipher
 * form.
 */

package demos;

import acm.program.*;

@SuppressWarnings("serial")
public class CaesarCipher extends ConsoleProgram {
	
	public void run() {
		println("This program uses a Caesar cipher to encrypt" +
				"a message.");
		int key = readInt("Enter the encryption key: ");
		String plaintext = readLine("Enter the plaintext: ");
		String ciphertext = encryptCaesar(plaintext, key);
		println("The ciphertext is: " + ciphertext);
	}
	
	/*
	 * Encrypts a string by adding the value of key to each 
	 * character.  The first line of the method makes sure that
	 * the key is positive, by converting a negative key to the
	 * equivalent positive one.
	 */
	private String encryptCaesar(String str, int key) {
		if (key < 0) key = 26 - (-key % 26);
		String result = "";
		for (int i = 0; i < str.length(); i++) {
			char ch = str.charAt(i);
			if (Character.isLetter(ch)) {
				ch = (char) (
				      'A' 
				        + 
				      (Character.toUpperCase(ch) - 'A' + key) % 26
				      );
			}
			result += ch;
		}
		return result;
	}

}
