/*
 * File: ReverseFile.java
 * ----------------------
 * This program displays the lines in a file in reverse order.
 */

package demos;

import acm.program.*;
import acm.util.*;
import java.io.*;
import java.util.*;

@SuppressWarnings("serial")
public class ReverseFile extends ConsoleProgram {	

/** Runs the program */
	public void run() {
		BufferedReader rd = openInputFile("Input file: ");
		try {
			ArrayList lines = new ArrayList();
			while (true) {
				String line = rd.readLine();
				if (line == null) break;
				lines.add(line);
			}
			for (int i = lines.size() - 1; i >= 0; i--) {
				println(lines.get(i));
			}
		} catch (IOException ex) {
			throw new ErrorException("An IOException occurred");
		}
	}

/**
 * Asks the user for the name of an input file and returns a
 * BufferedReader attached to its contents.  If the file does
 * not exist, the user is given another chance to try.
 */
	private BufferedReader openInputFile(String prompt) {
		BufferedReader rd = null;
		while (rd == null) {
			try {
				String name = readLine(prompt);
				rd = new BufferedReader(new FileReader(name));
			} catch (IOException ex) {
				println("Can't open that file.");
			}
		}
		return rd;
	}
}

