/*
 * File: ScrabbleScore.java
 * ------------------------
 * This program reads in words and calculates their score in
 * Scrabble.  Only uppercase letters count, so that it is possible
 * to use lowercase letters to indicate blanks, so that the input
 * "QUIZzICAL" shows that the second Z is actually a blank.
 */

package demos;

import acm.program.*;

@SuppressWarnings("serial")
public class ScrabbleScore extends ConsoleProgram {	

/** Runs the program */
	public void run() {
		println("Program to compute Scrabble scores");
		while (true) {
			String word = readLine("Enter a word: ");
			if (word.length() == 0) break;
			println(word + " scores " + scoreScrabbleWord(word));
		}
		println("Goodbye.");
	}

/** Computes the score for a Scrabble word */ 
	private int scoreScrabbleWord(String word) {
		int score = 0;
		for (int i = 0; i < word.length(); i++) {
			score += scoreScrabbleLetter(word.charAt(i));
		}
		return score;
	}

/** Computes the score for a Scrabble letter */ 
	private int scoreScrabbleLetter(char ch) {
		if (!Character.isUpperCase(ch)) return 0;
		switch (ch) {
		  case 'Q': case 'Z': return 10;
		  case 'J': case 'X': return 8;
		  case 'K': return 5;
		  case 'F': case 'H': case 'V': case 'W': case 'Y': return 4;
		  case 'B': case 'C': case 'M': case 'P': return 3;
		  case 'D': case 'G': return 2;
		  default: return 1;
		}
	}
}

